
' FixIcon by David M. Pochron v.1.0  7/16/88
' Sets icon to 3 bitplanes so system won't crash in 16-color WB

' (Yes folks I could program this in C or assembly but what the heck...it works.)


DEFLNG a-z

DECLARE FUNCTION PutDiskObject LIBRARY
DECLARE FUNCTION GetDiskObject LIBRARY

LIBRARY "icon.library"

INPUT "Enter icon name (no .info) > ",f$:f$=f$+CHR$(0)
obj=GetDiskObject(SADD(f$))
IF obj<>0 THEN
  img1=PEEKL(obj+22):img2=PEEKL(obj+26)
  'GOSUB show    'unREM this if you want to see all of icon's struct. values
  a=PEEKW(img1+8)
  PRINT "Icon has";a;"bitplanes and ";
  IF img2=0 THEN
    PRINT "no alt image."
    PRINT :PRINT "Since 4-color icons with no alt image work fine"
    PRINT "in the 16-color WB do you still wish to force it to 3 bitplanes";
    INPUT a$:IF UCASE$(a$)<>"Y" THEN cleanup
  ELSE
    PRINT "has an alt. image."
  END IF
  IF PEEKW(obj+16)=5 THEN PRINT :PRINT "Cannot fix backfill icons due to system incompatability.":PRINT "(Backfill only works in 4-color WB on 1.2)":GOTO cleanup
  IF a<3 THEN                'check depth to see if fix is needed
    PRINT "Fixing...";
    POKEW img1+8,3           'set depth
    POKE img1+14,3           'set planepick
    IF img2<>0 THEN POKEW img2+8,3:POKE img2+14,3   'do same for alt image if exists
    e=PutDiskObject(SADD(f$),obj)
    IF e=0 THEN PRINT "  Error writing icon!" ELSE PRINT "Done."
  ELSE
    PRINT "No need to fix...enough bitplanes already."
  END IF
  cleanup:FreeDiskObject obj
ELSE
  PRINT "No icon found by that name!"
END IF

LIBRARY CLOSE
END
  
    
show:
PRINT obj
PRINT PEEKW(obj+0),"magic number"
PRINT PEEKW(obj+2),"version"
PRINT "gadget structures (at +4)"
PRINT "  ";PEEKL(obj+4),"Next gadget"
PRINT "  ";PEEKW(obj+8),"Leftedge"
PRINT "  ";PEEKW(obj+10),"Topedge"
PRINT "  ";PEEKW(obj+12),"X size"
PRINT "  ";PEEKW(obj+14),"Y size"
PRINT "  ";PEEKW(obj+16),"Activation type"
PRINT "  ";PEEKW(obj+20),"Gadget type
PRINT "  ";PEEKL(obj+22),"image structptr."
img=img1:GOSUB imagemap
PRINT "  ";PEEKL(obj+26),"alt. imageptr"
img=img2:GOSUB imagemap
PRINT "  ";PEEKL(obj+30),"intuitext ptr"
PRINT "  ";PEEKL(obj+38),"Specialinfo"
PRINT "  ";PEEKW(obj+42),"I.D."
PRINT PEEK(obj+48),"Icon type"
PRINT PEEKL(obj+52),"default tool"
PRINT PEEKL(obj+54),"tooltypes"
PRINT PEEKL(obj+58),"current xpos"
PRINT PEEKL(obj+62),"current ypos"
PRINT PEEKL(obj+66),"drawer data"
PRINT PEEKL(obj+70),"tool window"
PRINT PEEKL(obj+74),"stack"
RETURN

imagemap:
IF img=0 THEN RETURN
PRINT "    ";PEEKW(img),"Leftedge"
PRINT "    ";PEEKW(img+2),"TopEdge"
PRINT "    ";PEEKW(img+4),"Width"
PRINT "    ";PEEKW(img+6),"Height"
PRINT "    ";PEEKW(img+8),"Depth"
PRINT "    ";PEEKL(img+10),"Image data ptr."
PRINT "    ";PEEK(img+14),"PlanePick"
PRINT "    ";PEEK(img+15),"PlaneOnOff"
PRINT "    ";PEEKL(img+16),"Next Image"
RETURN

